/* varargs.c
 *
 * This program demonstrates the use of variable argument functions.
 *
 */

#include<stdarg.h>
#include<stdio.h>
#include<string.h>

void main(void);
void var_args(char *message,...);
void message(char *message,...);
char *cat(char *dest,...);
int largest(int x,...);
int average(int x,...);

void var_args(char *message,...)
    {
    va_list argptr;
    int value;

    printf("message=%s\n",message);            

    va_start(argptr,message);              
    while((value = (int)va_arg(argptr,int)) != -1)
        printf("value=%d\n",value);
    va_end(argptr);                        
    }

void message(char *message,...)
    {
    va_list argptr;

    va_start(argptr,message);              
    vprintf(message,argptr);               
    va_end(argptr);                        
    }

char *cat(char *dest,...)
    {
    va_list argptr;
    char *next;

    va_start(argptr,dest);
    while((next = (char *)va_arg(argptr,char *)) != NULL)
        strcat(dest,next);
    va_end(argptr);
    return dest;
    }

int largest(int x,...)
    {
    va_list argptr;
    int largest = x, thisarg;

    va_start(argptr,x);
    while((thisarg = (int)va_arg(argptr,int)) != -1)
        if(thisarg > largest)
            largest = thisarg;
    va_end(argptr);
    return largest;
    }

int average(int x,...)
    {
    va_list argptr;
    int av = x, thisarg, count = 1;

    va_start(argptr,x);
    while((thisarg = (int)va_arg(argptr,int)) != -1)
        {
        av += thisarg;
        count++;
        }
    va_end(argptr);
    return (av ? (av / count) : 0);
    }


char buf[200];
void main(void)
    {
    var_args("The arguments are: 10,9,8 and 7",10,9,8,7,-1);
    message("The arguments are: %d,%d,%d and %d\n",10,9,8,7);
    buf[0] = '\0';
    printf(cat(buf,"This ","is ","a ","test.\n",NULL));
    printf("largest in list is %d\n",largest(10,20,30,40,50,60,70,-1));
    printf("average is %d\n",average(10,20,30,40,50,60,70,-1));
    }

