unit xtra31;

{

This unit provides interface definitions for TPW 1.0 for the handful of
Windows 3.1 functions that the CDDEMO program uses.  CDDemo requires
Windows 3.1 to run, but it can be compiled with TPW 1.0 or TPW 1.5.

  This file is needed only for TPW 1.0.  The Win31.pas unit shipped with
TPW 1.5 supercedes this file.

}

interface

uses winprocs, wintypes;

type
  PDocInfo = ^TDocInfo;
  TDocInfo = record
    cbSize: Integer;
    lpszDocName: PChar;
    lpszOutput: PChar;
  end;

type
  TAbortProc = function (DC: HDC; Error: Integer): Boolean;

function StartDoc(DC: HDC; var di: TDocInfo): Integer;
function StartPage(DC: HDC): Integer;
function EndPage(DC: HDC): Integer;
function EndDoc(DC: HDC): Integer;
function AbortDoc(DC: HDC): Integer;
function SetAbortProc(DC: HDC; AbortProc: TAbortProc): Integer;

implementation

function StartDoc;                       external 'GDI'      index 377;
function StartPage;                      external 'GDI'      index 379;
function EndPage;                        external 'GDI'      index 380;
function EndDoc;                         external 'GDI'      index 378;
function AbortDoc;                       external 'GDI'      index 382;
function SetAbortProc;                   external 'GDI'      index 381;

end.